{% extends 'base.html.twig' %}

{% block stylesheets %}

    <style>
        @import url('https://fonts.googleapis.com/css2?family=Roboto&family=Squada+One&display=swap');
        @import url('https://fonts.googleapis.com/css2?family=Work+Sans:wght@200;400&display=swap');
        @import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@500&display=swap');
        @import url('https://fonts.googleapis.com/css2?family=Ubuntu:wght@500&display=swap');

        *, ::after, ::before {
            box-sizing: border-box;
        }

        html {
            background-color: #0a0717;
        }

        body {
            width: 100vw;
            height: 100vh;
            margin: 0;
            font-family: 'Roboto', sans-serif;
            overflow: hidden;
            background: radial-gradient(
                    circle,
                    rgba(10, 7, 23, 0.12648809523809523) 0%,
                    rgba(10, 7, 23, 0.4906337535014006) 31%,
                    rgba(10, 7, 23, 1) 78%),
            url('https://cdn.discordapp.com/attachments/775414438924779570/776183635342393354/fixe.png') no-repeat;
            background-size: contain;
            background-position: center 300px;
            box-shadow: inset 00px -10px 100px 100px #0a0717;
        }

        #main-center {
            position: relative;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -60%);
            width: 800px;
            background: #f7f7f7;
            height: 500px;
            border-radius: 15px;
            box-shadow: 15px 15px #898989;
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }

        #form-header {
            width: 35%;
            background: #1E1C26;
            border-radius: 20px 20px 0 0;
            display: flex;
            letter-spacing: 1.2px;
            font-weight: bold;
            color: white;
            text-transform: uppercase;
            text-align: center;
            justify-content: center;
            position: absolute;
            top: -50px;
            padding: 15px 0;
        }

        #container-page1 {
            width: 90%;
            height: 85%;
            display: flex;
            flex-direction: row;
            margin-top: 30px;
        }

        #left-page1 {
            width: 50%;
            height: 100%;
        }

        #skin-gender-selector-container {
            width: 40px;
            height: 100px;
            position: absolute;
            top: 80px;
            color: white;
            left: 289px;
            z-index: 1;
            transform: translateX(-50%);
            border-radius: 8px 8px 0 0;
            text-align: center;
            text-transform: uppercase;
            font-weight: bold;
            letter-spacing: 1.5px;
        }

        #skin-gender-selector-container button {
            width: 35px;
            height: 35px;
            border-radius: 10px;
            margin: 1px;
            background: #1E1C26;
            color: white;
            outline: none;
            border: 0;
            transition: all 0.2s;
        }

        #skin-gender-selector-container button:hover {
            background: #24222d;
        }

        .gender-active {
            filter: brightness(0) invert(1);
        }

        .gender-nonactive {
            filter: invert(63%) sepia(11%) saturate(7%) hue-rotate(4deg) brightness(91%) contrast(88%);
        }

        #skin-selector-container {
            width: 250px;
            height: 100%;
            padding-bottom: 12px;
            background: #1E1C26;
            border-radius: 15px;
            display: flex;
            justify-content: center;
            position: relative;
            flex-direction: column;
            align-items: center;
        }

        #skin-selector-header {
            width: 130px;
            position: absolute;
            top: -20px;
            background: #1E1C26;
            color: white;
            padding: 5px;
            left: 50%;
            transform: translateX(-50%);
            border-radius: 8px 8px 0 0;
            text-align: center;
            font-weight: bold;
            text-transform: uppercase;
            letter-spacing: 1.5px;
        }

        #skin-gender-selector-container {
            width: 40px;
            height: 100px;
            position: absolute;
            top: 80px;
            color: white;
            left: 289px;
            z-index: 1;
            transform: translateX(-50%);
            border-radius: 8px 8px 0 0;
            text-align: center;
            font-weight: bold;
            text-transform: uppercase;
            letter-spacing: 1.5px;
        }

        #skin-gender-selector-container button {
            width: 35px;
            height: 35px;
            border-radius: 10px;
            margin: 1px;
            background: #1E1C26;
            color: white;
            outline: none;
            border: 0;
            transition: all 0.2s;
        }

        #skin-gender-selector-container button:hover {
            background: #24222d;
        }

        #skin-selector-skin {
            height: 80%;
            margin-top: 20px;
            display: flex;
            justify-content: center;
            background: url('https://cdn.discordapp.com/attachments/775414438924779570/776187008518979614/plateform.png') no-repeat;
            background-size: 120px;
            background-position: center 200px;
            position: relative;
            animation: float 6s ease-in-out infinite;
        }

        .skin-selector-switch {
            height: 100%;
            display: flex;
            justify-content: center;
            align-items: center;
        }

        #skin-selector-preview {
            width: 120px;
            height: 77%;
        }

        .skin-circle-selector {
            width: 40px;
            height: 40px;
            border-radius: 40px;
            background: rgb(255 255 255 / 49%);
            display: flex;
            justify-content: center;
            align-items: center;
            color: #1e1c26;
            font-weight: bold;
            font-size: 20px;
            cursor: pointer;
            user-select: none;
        }

        .gender-selection:hover {
            cursor: pointer;
        }

        .skin-circle-selector:hover {
            background: rgb(255 255 255 / 62%);
            cursor: pointer;
            transition: all 0.2s;
        }

        .button-shop {
            width: 130px;
            height: 30px;
            background: white url('/public/assets/images/form/gold.jpg') no-repeat;
            background-position: -20px -20px;
            border-radius: 10px;
            background-size: 300px;
            justify-content: center;
            color: #1e1c26;
            align-items: center;
            cursor: pointer;
            display: flex;
            text-transform: uppercase;
            font-weight: bolder;
            font-family: 'Work Sans', sans-serif;
            transition: all 0.2s;
        }

        .button-shop:hover {
            color: #1e1c26;
            transition: all 0.2s;
        }

        .gratuit {
            background: #e0e0e0;
            cursor: default;
        }

        .button-shop:hover {
            color: #1e1c26;
            transition: all 0.2s;
        }

        #right-page1 {
            width: 60%;
            height: 100%;
            display: flex;
            flex-direction: column;
            align-items: center;
        }

        #welcome-title {
            padding: 20px 0;
            width: 200px;
            height: 100px;
            text-align: center;
            justify-content: center;
            display: flex;
            text-transform: uppercase;
            flex-direction: column;
            margin-top: 20px;
            color: #1e1c26;
        }

        #welcome-title h1 {
            font-size: 35px;
            font-weight: bolder;
            letter-spacing: 1px;
            margin-bottom: 10px;
        }

        #welcome-title h2 {
            font-size: 14px;
            letter-spacing: 1px;
            font-weight: bold;
            color: #6d6d6d;
            margin: 0 0 30px 0;
        }

        #right-page h1 {
            font-size: 14px;
        }

        #input-pseudo {
            width: 100%;
            height: 50px;
            margin-top: 40px;
            text-align: center;
            justify-content: center;
            display: flex;
            text-transform: uppercase;
            padding: 0 10px;
        }

        #input-pseudo input {
            width: 90%;
            background: #1E1C26;
            border-radius: 15px;
            outline: none;
            border: 0;
            color: white;
            padding: 30px 40px;
            text-align: center;
            text-transform: uppercase;
        }

        #input-pseudo input::placeholder {
            color: #c5c5c5;
        }

        #nav-bar-page1 {
            width: 100%;
            height: 90%;
            display: flex;
            align-items: center;
            justify-content: center;

        }

        #nav-bar-bottom {
            width: 100%;
            height: 50px;
            display: flex;
            align-items: center;
            justify-content: center;
        }

        .nav-bar-button {
            margin: 20px;
            padding: 20px;
            width: 200px;
            height: 50px;
            background: #1E1C26;
            outline: outline;
            border: 0;
            border-radius: 10px;
            display: flex;
            align-items: center;
            justify-content: center;
            text-align: center;
            color: white;
            text-transform: uppercase;
            font-weight: bold;
            letter-spacing: 1px;
            font-size: 14px;
            transition: all 0.2s;
        }

        .nav-bar-button:hover {
            background: #36343e;
            cursor: pointer;
        }

        button {
            outline: none;
        }

        #formJoin {
            display: none;
        }

        @keyframes float {
            0% {
                transform: translatey(0px);
            }
            50% {

                transform: translatey(-10px);
            }
            100% {
                transform: translatey(0px);
            }
        }

    </style>
{% endblock %}

{% block body %}
    <main id="main-center">
        <div id="form-header">Création de la partie</div>
        <div id="container-page1" data-platformurl="{{ platformUrl }}" data-currentindex="0" data-currenttype="F" data-slug="{{ slug }}">
            <div id="left-page1">
                <div id="skin-gender-selector-container">
                    <button id="btn-gender-male" title="Hommes" class="gender-selection">
                        <img id="male" class="gender-nonactive"
                             src="{{ asset('assets/images/form/male.svg') }}"
                             alt="men_symbol"
                             width=16
                        >
                    </button>
                    <button id="btn-gender-female" title="Femmes" class="gender-selection">
                        <img id="female" class="gender-active"
                             src="{{ asset('assets/images/form/female.svg') }}"
                             alt="men_symbol"
                             width=12
                        >
                    </button>
                </div>
                <div id="skin-selector-container">
                    <div id="skin-selector-header">Skin</div>
                    <div id="skin-selector-skin">
                        <div class="skin-selector-switch">
                            <div id="btn-skin-previous" class="skin-circle-selector"><</div>
                        </div>
                        <img id="skin-selector-preview" data-id="6" src="{{ asset('assets/images/skins/Sage.svg') }}">
                        <div class="skin-selector-switch">
                            <div id="btn-skin-next" class="skin-circle-selector">></div>
                        </div>
                    </div>
                    <div class="button-shop gratuit">Gratuit</div>
                </div>
            </div>
            <div id="right-page1">
                <div id="welcome-title">
                    <h1>Bienvenue</h1>
                    <h2>Change ton skin et rejoint la partie</h2>
                </div>
                <div id="input-pseudo">
                    <input id="inputPseudo" required autofocus maxlength=14 placeholder="Pseudo" type="text" value="{{ user ? user.username : '' }}">
                </div>
                <div id="nav-bar-page1">
                    <div id="nav-bar-bottom">
                        <button id="btn-page1-home" class="nav-bar-button">Accueil</button>
                        <button id="btn-page1-next" class="nav-bar-button">Rejoindre</button>
                    </div>
                </div>
            </div>
        </div>
    </main>
    {{ form_start(formJoin, {"attr": {"id": "formJoin"}}) }}
    <input id="formJoinUsername" type="hidden" name="formJoinUsername">
    <input id="formJoinSkinId" type="hidden" name="formJoinSkinId">
    <input id="formJoinSlug" type="hidden" name="formJoinSlug">
    {{ form_end(formJoin) }}
{% endblock %}

{% block javascripts %}
    <script>
        const containerPage1 = document.getElementById('container-page1');
        const skinSelectorPreview = document.getElementById('skin-selector-preview');

        const btnPage1Home = document.getElementById('btn-page1-home');
        const btnPage1Next = document.getElementById('btn-page1-next');
        btnPage1Home.addEventListener('click', () => onPressedBtnPage1Home());
        btnPage1Next.addEventListener('click', () => onPressedBtnPage1Next());

        const platformUrl = containerPage1.dataset.platformurl;

        const btnGenderMale = document.getElementById('btn-gender-male');
        const imgMale = document.getElementById('male');
        btnGenderMale.addEventListener('click', (e) => {
            e.preventDefault();
            imgFemale.classList.remove('gender-active');
            imgFemale.classList.add('gender-nonactive');
            imgMale.classList.remove('gender-nonactive');
            imgMale.classList.add('gender-active');
            containerPage1.dataset.currenttype = 'M';
            containerPage1.dataset.currentindex = '0';
            fetchSkinWithParameters();

        });
        const btnGenderFemale = document.getElementById('btn-gender-female');
        const imgFemale = document.getElementById('female');
        btnGenderFemale.addEventListener('click', (e) => {
            e.preventDefault();
            imgMale.classList.remove('gender-active');
            imgMale.classList.add('gender-nonactive');
            imgFemale.classList.remove('gender-nonactive');
            imgFemale.classList.add('gender-active');
            containerPage1.dataset.currenttype = 'F';
            containerPage1.dataset.currentindex = '0';
            fetchSkinWithParameters();
        });

        let totalSkin = 0;
        const btnSkinPrevious = document.getElementById('btn-skin-previous');
        btnSkinPrevious.addEventListener("click", (e) => {
            e.preventDefault();
            let currentIndex = containerPage1.dataset.currentindex;
            currentIndex--;
            if (parseInt(currentIndex) === -1) {
                currentIndex = totalSkin - 1;
            }
            containerPage1.dataset.currentindex = currentIndex;
            fetchSkinWithParameters();
        })
        const btnSkinNext = document.getElementById('btn-skin-next');
        btnSkinNext.addEventListener("click", (e) => {
            e.preventDefault();
            let currentIndex = containerPage1.dataset.currentindex;
            currentIndex++;
            if (parseInt(currentIndex) > totalSkin - 1) {
                currentIndex = 0;
            }
            containerPage1.dataset.currentindex = currentIndex;
            fetchSkinWithParameters();
        })

        const fetchSkinWithParameters = () => {
            fetch(platformUrl + '/api/skins', {
                headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json'
                },
                method: "POST",
                body: JSON.stringify({
                    currentIndex: containerPage1.dataset.currentindex,
                    type: containerPage1.dataset.currenttype,
                })
            }).then((res) => {
                return res.json();
            }).then((data) => {
                data = data.data;
                name = data.name;
                totalSkin = data.totalSkin;
                id = data.id;

                skinSelectorPreview.dataset.id = id.toString();
                skinSelectorPreview.setAttribute('src', '/assets/images/skins/' + name);
            });
        }

        const formJoin = document.getElementById('formJoin');
        inputPseudo = document.getElementById("inputPseudo");
        const onPressedBtnPage1Next = () => {
            if (!inputPseudo.value) {
                inputPseudo.style.boxShadow = "inset 0px 0px 0px 4px #EF5350";
            } else {
                const formJoinUsername = document.getElementById('formJoinUsername');
                const formJoinSkinId = document.getElementById('formJoinSkinId');
                const formJoinSlug = document.getElementById('formJoinSlug');
                formJoinUsername.value = inputPseudo.value;
                formJoinSkinId.value = skinSelectorPreview.dataset.id;
                formJoinSlug.value = containerPage1.dataset.slug;
                formJoin.submit();
            }
        }
    </script>
{% endblock %}